function playerEntry(id, name, duration, goals, assists){
  var kid = new Object();
  
  kid.id = id;
  kid.name = name;
  kid.duration = duration;
  kid.goals = goals;
  kid.assists = assists;
  kid.Start = null;
  kid.Active = false;
  kid.timer = null;
  
  return kid;
}

var trackerData = {
    games: [
      {
        id:1, 
        team:  [ 
          playerEntry(1, "Player 1", 0, 0, 0) 
        ]
        , date: new Date()
      }    
    ],
    "InEditMode": false
  };

function game(date, team){
  
}

function team(){
  
}

function timeEntry(start, stop){
  var entry = new Object();
  
  entry.start = new ko.observable(start);
  entry.end = new ko.observable(stop);
  entry.duration = new ko.computed(function(){
    return entry.end - entry.start;
  });
  
  return entry();
}

ko.bindingHandlers.buttonText = {
  //Init is different than update since it happens before jQm enhances the text, and update happens after.
  init: function (element, valueAccessor, allBindingsAccessor, viewModel) {    
    var textOb = valueAccessor();    
    var text = ko.utils.unwrapObservable(textOb); 

    if(element.childNodes.length > 0){
      $(element).find(".ui-btn-text").text(text);
    } else {
      element.innerHTML = text;
    }
  },
  update: function (element, valueAccessor, allBindingsAccessor, viewModel) {
    var textOb = valueAccessor();
    var text = ko.utils.unwrapObservable(textOb); 
    
    $(element).find(".ui-btn-text").text(text); //Update text of span, since updating button text removes spans added by jQm.
  }
};

ko.bindingHandlers.datevalue = {
    init: function (element, valueAccessor, allBindingsAccessor, viewModel) {
        var jsonDate = valueAccessor();
        ret = "";
        if (jsonDate != null) {
            if(typeof jsonDate() == 'string'){ 
              jsonDate(jsonDate().replace(/\"/g, '')); //bugfix for double JSON encoding by JSON.stringify.
            }
            
            var value = new Date(jsonDate());
            ret = value.getMonth() + 1 + "/" + value.getDate() + "/" + value.getFullYear();
        }
        element.innerHTML = ret;
    },
    update: function (element, valueAccessor, allBindingsAccessor, viewModel) {
        var jsonDate = valueAccessor();
        ret = "";
        if (jsonDate != null) {
            if(typeof jsonDate() == 'string'){ 
              jsonDate(jsonDate().replace(/\"/g, '')); //bugfix for double JSON encoding by JSON.stringify.
            }
            
            var value = new Date(jsonDate());
            ret = value.getMonth() + 1 + "/" + value.getDate() + "/" + value.getFullYear();
        }
        element.innerHTML = ret;
    }
};

ko.bindingHandlers.stopwatch = {
    init: function (element, valueAccessor, allBindingsAccessor, viewModel) {
      var durOb = valueAccessor();    
      var dur = ko.utils.unwrapObservable(durOb); 
      
      var durString = durFormat(dur);
      
      element.innerHTML = durString;
    },
    update: function (element, valueAccessor, allBindingsAccessor, viewModel) {
      var durOb = valueAccessor();    
      var dur = ko.utils.unwrapObservable(durOb); 
      
      var durString = durFormat(dur);
      
      element.innerHTML = durString;
    }
}

function gridClass(index){
  var decider = index%3;
  
  switch(decider){
    case 0:
      return "ui-block-a";
      break;
    case 1:
      return "ui-block-b";
      break;
    case 2:
      return "ui-block-c";
      break;
  }
}

function gridClassLast() {
    return gridClass(model.currentGame().team().length);    
}

function durFormat(dur){
  var workingTime = dur;
  
  var min = Math.floor(workingTime/60000);
  
  workingTime -= min*60000;
  
  var sec = Math.floor(workingTime/1000);
  
  workingTime -= sec*1000;
  
  var tenths = Math.floor(workingTime/100);
  
  if(sec < 10){
    sec = "0" + sec;
  }

  return min + ":" + sec + "." + tenths;
}

//test for local storage 
var model = ko.mapping.fromJSON(localStorage.getItem('SportsTimeTracker'));
if (model.InEditMode == null) {
    //load default
    model = ko.mapping.fromJS(trackerData);
}
//Turn Edit Mode Off 
model.InEditMode(false);
//Reset all interval objects
for (var i = 0; i < model.games().length; i++) {
  var game = model.games()[i];
  for (var x = 0 ; x < game.team().length; x++) {
    game.team()[x].timer(null);
  }
}

model.AddNewPlayer = function (item) {
    model.currentGame().team().push(ko.mapping.fromJS(playerEntry(1, "Player " + (model.currentGame().team().length+1), 0, 0, 0)));
    model.SaveGame(item);
    //localStorage.setItem('SportsTimeTracker',ko.toJSON(model));
    $('.currentGameItem').trigger('create');
}

model.ChangeEditMode = function (item) { 
    model.InEditMode(!model.InEditMode()); 
}

model.Next = function (item) {    
    findGame(model.currentGame().id() + 1);
    $('.currentGameItem').trigger('create');
}

model.Prev = function (item) {
    findGame(model.currentGame().id() - 1);
    $('.currentGameItem').trigger('create');
}

model.SelectedPlayerName = new ko.observable();

model.NewGame = function (item) {    
    model.SaveGame(item);
    var newGame = { id: model.games()[model.games().length - 1].id() + 1, team: [playerEntry(1, "New Player 1", 0, 0, 0)], date: new Date().toDateString() };        
    model.currentGame(ko.mapping.fromJS(newGame));
    model.SaveGame(item);
    //localStorage.setItem('SportsTimeTracker', ko.toJSON(model));
    location.reload();
}

model.SaveGame = function (item) {
  //Check if current game needs to be saved on the end or update current item.
  var currentGameId = model.currentGame().id();
  var newGame = true;
  for (var i = 0 ; i < model.games().length; i++) {
    var game = model.games()[i];        
    if (game.id() == currentGameId) {
      model.games()[i].id(model.currentGame().id());
      model.games()[i].team(model.currentGame().team());
      model.games()[i].date(model.currentGame().date());
      newGame = false;
      break;
    }
  }
  
  if (newGame) {
    model.games.push(model.currentGame);
  }
  
  localStorage.setItem('SportsTimeTracker', ko.toJSON(model));
}

model.SaveName = function (item) {
    var player = model.SelectedPlayer;
    player.name(model.SelectedPlayerName());
    $('#popupBasic').popup('close');
    //localStorage.setItem('SportsTimeTracker',ko.toJSON(model));
    model.SaveGame(item);
}

model.CancelName = function (item) {
    $('#popupBasic').popup('close');
    model.SelectedPlayer = null;
    model.SelectedPlayerName('');
}

model.EditName = function (item) {
    $('#popupBasic').popup('open');
    model.SelectedPlayerName(item.name());
    model.SelectedPlayer = item;
}

model.currentGame = ko.observable(model.games()[model.games().length - 1]);

function findGame(prev) {
    for (var i = 0 ; i < model.games().length; i++) {
        var game = model.games()[i];
        if (game.id() == prev) {
            model.currentGame(game);
            
            break;
        }
    }
}

model.ActiveIntervals = [];

model.ToggleTimer = function (item) {
    if(item.timer() == null) {
        item.Start(Date.now() - item.duration()); //Reset start time.
        item.Active(true);
      
        item.timer(window.setInterval(
            function () {
                item.duration(Date.now() - item.Start());
            },
        100));        
    }
    else {
        window.clearInterval(item.timer())
        item.timer(null);
        item.Active(false);
        model.SaveGame(item);        
    }     
}

$(document).ready(function() {
  ko.applyBindings(model, $("body")[0]);
  
  for( i in model.games()[0].team() ){
    var player = model.games()[0].team()[i];
    if(player.Active()){
      model.ToggleTimer(player);
    }
  }
});

function updateTimers(model) {
  //Find all active timers
  
  //set timeout for update if any timers are active
  //TODO part of major later code change.
}

//Phonegap setup calls
document.addEventListener("deviceready", onDeviceReady, false);

function onDeviceReady() {
  document.addEventListener("pause", appPause, false);
  //console.log("****************\nSoccer Tracker model\n************************\n\n" + ko.toJSON(model));
}

function appPause(){
  //console.log("****************\nSoccer Tracker Pause Handled\n************************");
  model.SaveGame();
}
